package com.edunetcracker.simulator.service;

import com.edunetcracker.simulator.database.repository.LinkRepository;
import com.edunetcracker.simulator.model.Link;
import com.edunetcracker.simulator.model.Scene;
import com.edunetcracker.simulator.model.port.Port;
import com.edunetcracker.simulator.service.status.SequenceStatus;
import lombok.Getter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import sun.reflect.generics.reflectiveObjects.NotImplementedException;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

@Service
public class LinkService extends DBService<Link> {
    Logger logger = LoggerFactory.getLogger(LinkService.class);


    private final LinkRepository linkRepository;
    private final PortService portService;

    @Getter
    private List<Link> loadedLinks = new ArrayList<>();

    @Autowired
    public LinkService(LinkRepository linkRepository, PortService portService) {
        this.linkRepository = linkRepository;
        this.portService = portService;
    }

    @Override
    public Link getLoaded(long id) {
        for (Link link : loadedLinks) {
            if (link.getId() == id) {
                return link;
            }
        }
        return null;
    }

    /**
     * "DON'T USE | DON'T USE | DON'T USE | DON'T USE | DON'T USE |
     * "DON'T USE | DON'T USE | DON'T USE | DON'T USE | DON'T USE |
     * "DON'T USE | DON'T USE | DON'T USE | DON'T USE | DON'T USE |
     * @param id ID of a Link to seek
     * @return MAY RETURN AN INSTANCE WITHOUT AN OWNER
     */
    @Deprecated
    @Override
    public Link get(long id) {
        Link loadedLink = getLoaded(id);
        if (null != loadedLink) {
            return null;
        }
        Optional<Link> newlyLoaded = linkRepository.findById(id);
        if (!newlyLoaded.isPresent()) {
            SequenceStatus.NOT_FOUND_IN_DATABASE.logWarning("Link", id);
            return null;
        }
        return newlyLoaded.get();
    }

    @Override
    public SequenceStatus create(Link link) {
        if (null == link) {
            SequenceStatus.NULL_POINTER.logError("saveLink", "link");
            throw new NullPointerException();
        }
        long instanceId = link.getId();
        if (instanceId != 0) {
            SequenceStatus.UNEXPECTED_FIELD_VALUE.logError("0", "Link", "saveNew");
            return SequenceStatus.UNEXPECTED_FIELD_VALUE;
        }
        trackRecursively(link);
        update(link);
        return SequenceStatus.OK;
    }

    @Override
    public Link update(Link link) {
        if (null == link) {
            SequenceStatus.NULL_POINTER.logError("updateLink", "link");
            throw new NullPointerException();
        }
        if (null == getLoaded(link.getId())) {
            SequenceStatus.UNTRACKED_DB_OBJECT.logError("Link");
            trackRecursively(link);
        }
        Link savedLink = linkRepository.save(link);

        if (savedLink != link) {
            link.copyAutogeneratedValues(savedLink);
        }
        return link;
    }


    @Override
    public void trackRecursively(Link instance) {
        if (null == instance) {
            SequenceStatus.NULL_POINTER.logError("loadRecursively", "instance");
            throw new NullPointerException();
        }
        if (loadedLinks.contains(instance)) {
            return;
        }
        loadedLinks.add(instance);
    }

    @Override
    public void untrackRecursively (Link link) {
        if (null == link) {
            SequenceStatus.NULL_POINTER.logError("untrackRecursively", "link");
            throw new NullPointerException();
        }
        if (!loadedLinks.contains(link)) {
            SequenceStatus.UNTRACKED_DB_OBJECT.logError("LinkService");
            return;
        }
        loadedLinks.remove(link);
    }

    @Override
    public void drop(Link instance) {
        if (null == instance) {
            SequenceStatus.NULL_POINTER.logError("dropFromDB", "instance");
            throw new NullPointerException();
        }
        linkRepository.delete(instance);
    }

    public SequenceStatus delete (Link link) {
        throw new NotImplementedException();
    }

    /**
     * Deletes LOADED instance of link. Does nothing, if not loaded.
     * @param id
     * @return
     */
    public SequenceStatus delete(Long id) {
    //ToDo: Stop the queues
    //ToDo: Make synchronised
        if (null == id) {
            SequenceStatus.NULL_POINTER.logError("delete", "id");
            return SequenceStatus.NULL_POINTER;
        }
        Link loadedInstance = getLoaded(id);
        if (null == loadedInstance) {
            SequenceStatus.UNTRACKED_DB_OBJECT.logError("Link");
            return SequenceStatus.UNTRACKED_DB_OBJECT;
        }
        loadedInstance.getConnA().getPort().setConnection(null);
        loadedInstance.getConnA().nullifyFields();
        loadedInstance.getConnZ().getPort().setConnection(null);
        loadedInstance.getConnZ().nullifyFields();
        loadedInstance.setUp(false);
        untrackRecursively(loadedInstance);
        drop(loadedInstance);
        return SequenceStatus.OK;
    }

    public SequenceStatus linkComps (Long linkId) {
        if (null == linkId) {
            SequenceStatus.NULL_POINTER.logError("linkComps", "linkId");
            return SequenceStatus.NULL_POINTER;
        }
        if (null == getLoaded(linkId)) {
            return SequenceStatus.DUPLICATE_ID;
        }
        Optional<Link> linkOpt = linkRepository.findById(linkId);
        if (!linkOpt.isPresent()) {
            return SequenceStatus.NOT_FOUND_IN_DATABASE;
        }
        return linkComps(linkOpt.get());
    }

    public SequenceStatus linkComps (Link link) {
        if (null == link) {
            SequenceStatus.NULL_POINTER.logError("linkComps", "link");
            return SequenceStatus.NULL_POINTER;
        }

        Port portA = portService.getLoaded(link.getPortAid());
        Port portZ = portService.getLoaded(link.getPortZid());
        link.initLink(portA, portZ);

        portA.setConnection(link.getConnA());
        portZ.setConnection(link.getConnZ());


        if (0 == link.getId()) {
            Scene scene = SceneService.getInstance().getLoaded(link.getSceneId());
            if (null == scene) {
                SequenceStatus.UNTRACKED_DB_OBJECT.logError("Scene");
                throw new ArrayStoreException();
            }
            link.setScene(scene);
            scene.addLink(link);
            create(link);
        } else {
            trackRecursively(link);
            update(link);
        }
        return SequenceStatus.OK;
    }
}
